<?php
function ejournal_public_dispatcher() {
  $a = ejournal_path_get();
  
  /** UNCOMMENT THIS TO FIX LEGACY PATHS, REWRITE THEM TO THE NEW ONES
   /ejournal/term/{tids}/{depth}/feed -> /ejournal/feedterm/1/{depth}/{tid}
   /ejournal/$journal->jid/term/$term->tid -> /ejournal/term/{jid}/_/{tid}
  
  if($a['jid'] == 'print') { // /ejournal/{jid}/print
    $x = $a['jid'];
    $a['action'] = 'print';
    $a['jid'] = $x;
  }
  else if($a['jid'] == '' && $a['action']) { // /ejournal/{jid}
    $x = $a['jid'];
    $a['action'] = 'show';
    $a['jid'] = $x;
  }
  else if(substr($a['jid'], 0, 1) == 'v' && is_numeric($a['action'])) { // /ejournal/{jid}/v(xxxx)
    $x = $a['jid'];
    $a['jid'] = $a['action'];
    $a['action'] = 'show';
    $a['vid'] = $x;
    $a['iid'] = '';
  }
  */
  
  $action = $a['action'];
  $jid = $a['jid'];
  $vid = $a['vid'];
  $iid = $a['iid'];

	if (is_numeric($jid)) {
		$journal = ejournal_journal_get($jid);
	} else if ($jid) {
    $journal = ejournal_journal_get_by_path($jid);
  }

  if (!($action == 'show' || $action == 'browse')) {
    $default_action = 'show'; //this is used only for the ejournal_list_all_journals, does not have any special meaning
  }  
	if (!$journal) {
		print ejournal_theme('ejournal_list_all_journals', $default_action ? $default_action : $action);
		return;
	}
  
  switch ($action) {
		case 'print' :
      if (is_numeric($iid)) {
        $output = ejournal_theme('ejournal_display_issue', $journal, $iid, 1);
        print ejournal_theme('ejournal_page', $journal, "<div class=\"ejournal\">$output</div>");
      }
      else if (preg_match('/v(.+)/i', $vid, $match)) { // volume
        $volume = $match[1] ? $match[1] : '';        
        if ($volume && (!$issues = _ejournal_journal_get_issues($journal, $volume))) {
          drupal_set_message(t('The volume you requested doesn\'t exist'));
        }
        while($issue = db_fetch_object($issues)) {
          $output .= ejournal_theme('ejournal_display_issue', $journal, $issue->iid, 1);
        }
        print ejournal_theme('ejournal_page', $journal, "<div class=\"ejournal\">$output</div>");
        return;
      }
      else {
        $iid = ejournal_issue_current($journal->jid); //try to find the current issue
        if ($iid) {
          print ejournal_theme('ejournal_page', $journal, ejournal_theme('ejournal_display_issue', $journal, $iid, 1));
          return;
        }
      }
      break;
    case 'show' :
      if(is_numeric($iid)) {
        $output = ejournal_theme('ejournal_display_issue', $journal, $iid);
        print ejournal_theme('ejournal_page', $journal, $output);
      }
      else {
        preg_match('/v(.+)/i', $vid, $match); // volume
        $volume = $match[1] ? $match[1] : '';        
        if ($volume && (!$issues = _ejournal_journal_get_issues($journal, $volume))) {
          drupal_set_message(t('The volume you requested doesn\'t exist'));
        }
        print ejournal_theme('ejournal_archive', $journal, $issues); // if no issues, it will default to printing whole archive
      }
      return;
      break;
    case 'archive' : // list all issues in journal
			print ejournal_theme('ejournal_archive', $journal);
      break;
    case 'about' : // show about page
      print ejournal_theme('ejournal_about', $journal);
      break;
    case 'term' : // list nodes that belongs to taxonomy term
      if(strpos($iid, ':')) { //this comes from the list (eg. when viewing term/89)
        $passed_args = split(':', $iid);
        $iid = $passed_args[2];  //tid
      
      $depth = $passed_args[3] ? $passed_args[3] : 0; //depth
      $page = $passed_args[4] ? $passed_args[4] : 'page';
      
      $edit = $_POST ? $_POST : ($_GET['edit'] ? $_GET['edit'] : array ('tid' => $iid));
      $tids = implode('+', is_array($edit['tid']) ? $edit['tid'] : array ($edit['tid']));
      }
      else {
        $tids = $iid;
        $depth=0;
        $page='page';
      }
      
      print ejournal_theme('ejournal_taxonomy_term_page', $journal, $tids, $depth, $page);
      return;
    case 'list' : // browse vocabularies
    case 'browse' :  
      if (!$vid) {
        print ejournal_theme('ejournal_list_vocabularies', $journal);
        return;
      } else {
        print ejournal_theme('ejournal_list_vocabulary', $journal, $vid, $iid, arg(6));
        return;
      }
      break;
    case 'current' :
      $iid = ejournal_issue_current($journal->jid); //try to find the current issue
      if ($iid) {
        print ejournal_theme('ejournal_page', $journal, ejournal_theme('ejournal_display_issue', $journal, $iid));
        return;
      }
      break;      
    default: // the path was simply "/ejournal" 
      print ejournal_theme('ejournal_list_all_journals', $default_action); // last resort
  }

}

?>
